\input Head

\section{random}

\texttt{random} --- Generate psuesdorandom sequences of numbers

% A short (preferably one-line) description of \texttt{MyClass}.

\subsection{Description}

\texttt{random\/} is a suite of psuedorandom number generating functions
which can be used for creating uniformly distributed sequences
or normally distributed sequences. 
 
\subsection{Operating Instructions}

\subsubsection{Usage}

\texttt{random\/} contains 5 uniform psuedorandom number generators and a function
which uses one of the 5 generators to create normally distributed numbers.
The functions all require a state object of the appropriate type.
\begin{quote}
\footnotesize
\begin{verbatim}
  //: "Basic" Randomizing Function
  float ran0 (ran0state& s);
  //!param: ran0state& s - state object for random function
  //!return: float - a psuedo-random number between 0 and 1

  //: "Basic" Randomizing Function
  void ran0 (ran0state& s, valarray<float>& v, int size);
  //!param: ran0state& s - state objext for random function
  //!param: valarray<float>& v - array to hold random numbers
  //!param: int size - size of array upon return and the 
  // + quantity of random numbers in the array

  //: "Intermediate" Randomizing Function
  float ran1 (ran1state& s);
  //!param: ran1state& s - state object for random function
  //!return: float - a psuedo-random number between 0 and 1

  //: "Intermediate" Randomizing Function
  void ran1 (ran1state& s, valarray<float>& v, int size);
  //!param: ran1state& s - state objext for random function
  //!param: valarray<float>& v - array to hold random numbers
  //!param: int size - size of array upon return and the 
  // + quantity of random numbers in the array

  //: "Advanced" Randomizing Function
  float ran2 (ran2state& s);
  //!param: ran2state& s - state object for random function
  //!return: float - a psuedo-random number between 0 and 1

  //: "Advanced" Randomizing Function
  void ran2 (ran2state& s, valarray<float>& v, int size);
  //!param: ran2state& s - state objext for random function
  //!param: valarray<float>& v - array to hold random numbers
  //!param: int size - size of array upon return and the 
  // + quantity of random numbers in the array

  //: Subtractive Method Randomizing Function
  float ran3 (ran3state& s);
  //!param: ran3state& s - state object for random function
  //!return: float - a psuedo-random number between 0 and 1

  //: Subtractive Method Randomizing Function
  void ran3 (ran3state& s, valarray<float>& v, int size);
  //!param: ran3state& s - state objext for random function
  //!param: valarray<float>& v - array to hold random numbers
  //!param: int size - size of array upon return and the 
  // + quantity of random numbers in the array

  //: Randomizing Function using Hashing
  float ran4 (ran4state& s);
  //!param: ran4state& s - state object for random function
  //!return: float - a psuedo-random number between 0 and 1

  //: Randomizing Function using Hashing
  void ran4 (ran4state& s, valarray<float>& v, int size);
  //!param: ran4state& s - state objext for random function
  //!param: valarray<float>& v - array to hold random numbers
  //!param: int size - size of array upon return and the 
  // + quantity of random numbers in the array

  //: Function to Generate Random Normal Sequences
  float gasdev(gasdevstate& s);
  //!param: gasdevstate& s - state object for random function
  //!return: - returns a normally distributed deviate with zero mean
  // + and unit variance

  //: Function to Generate Random Normal Sequences
  void gasdev(gasdevstate& s, valarray<float>& v, int size);
  //!param: gasdevstate& s - state objext for random function
  //!param: valarray<float>& v - array to hold random numbers
  //!param: int size - size of array upon return and the 
  // + quantity of random numbers in the array
\end{verbatim}
\end{quote}

The state classes have identical construction, differing only in name.
I have included only \texttt{ran0state\/} and \texttt{gasdevstate\/};
the other states are similar to \texttt{ran0state\/}.

\texttt{ran0state\/}:
\begin{quote}
\footnotesize
\begin{verbatim}
    //: default constructor creates state with default seed
    ran0state();

    //: Construct with particular seed
    //!param: int - seed, must be negative
    //!exc: std::invalid_argument - seed >= 0 
    ran0state(int);

    //: Copy Constructor
    //:!param: const ranstate& - state to copy from
    ran0state(const ran0state&);
    
    ~ran0state() {};

    //: reset state with new seed
    //!param: unsigned long - seed, must be negative
    //!exc: std::out_of_range - if seed >= 0 
    void seed(int);

    //: Generate random number
    //!return: returns a random number
    float getran();

    //: Generate a sequence of random numbers
    //!param: valarray<float>& - array to be filled with numbers
    //!param: int - size of array (and quantity of generated numbers)
    void getran(valarray<float>&, int);
\end{verbatim}
\end{quote}

\texttt{gasdevstate\/}:
\begin{quote}
\footnotesize
\begin{verbatim}
    //: default constructor creates state with default seed
    gasdevstate();

    //: Construct with particular seed
    //!param: int - seed, must be negative
    //!exc: std::invalid_argument - seed >= 0
    gasdevstate(int& s);

    //: Copy Constructor
    //:!param: const ranstate& - state to copy from
    gasdevstate(const gasdevstate&);

    ~gasdevstate() {};

    //: Reset State with new seed
    //!param: int sd - seed, must be negative
    //!exc: std::invalid_argument - seed >=0
    void seed(int sd);

    //: Generate random number
    //!return: returns a random number
    float getgasdev();

    //: Generate a sequence of random numbers
    //!param: valarray<float>& - array to be filled with numbers
    //!param: int - size of array (and quantity of generated numbers)
    void getgasdev(valarray<float>&, int);

    gasdevstate* Clone() const;

    ILwd::LdasElement* ConvertToIlwd( const CallChain&,
                                      udt::target_t Target) const;
\end{verbatim}
\end{quote}

\subsubsection{Examples}

% A verbatim block of example code showing proper usage of {\tt
% MyClass}.

\begin{quote}
\footnotesize
\begin{verbatim}
//Default initialization of the seed value
ran0state s0;

//Initailization must be negative for some of the functions.
//Numbers between -1E8 and -2E8 are best.
ran1state s1(-284619304);

int size = n;
valarry<float> v(size);

//get a valarray full of random numbers
//both ways are essentially equivalent
for(int i=0;i<size();i++)
{
	v[i]=ran0(s0);
}
//or
ran1(s1,v,size);

//To reset a state (in order to get the same sequence of numbers for example)
s0.seed(-176389273);
\end{verbatim}
\end{quote}

\subsubsection{Options/Defaults}

% A list of options or defaults for public methods or member data of
% \texttt{MyClass}. 

The state function can use a default constructor and initialize the state
to an arbitrary value.

\subsection{Exceptions}

\subsubsection{Exceptions Thrown}

% A list of exceptions thrown by \texttt{MyClass}.
The state constructor which takes a integer seed 
and the seed function
to reset the state will both throw an invalid\_argument should the 
specified seed be >= 0.

\subsubsection{Exceptions Handled}

% A list of exceptions handled by \texttt{MyClass}.

None. 

\subsection{Algorithms}

% A discussion of the algorithms used by \texttt{MyClass}.
The \texttt{ran0\/} function is a basic linear congruential generator.
Such a generator works by using
\begin{equation}
I_{j+1}=a I_j \bmod m 
\end{equation}
to calculate the next value in the sequence.  For large $m$ 
Equation 14 yields numbers in a psuedorandom manner.

The \texttt{ran1\/} and \texttt{ran2\/} functions are also based on
the linear congruential generator.  \texttt{ran1\/} uses a shuffle table
to add another level of randomization, while \texttt{ran2\/} shuffles
and creates the random numbers in two halves.  \texttt{ran3\/} uses
a subtractive method suggested by Knuth. \texttt{ran4\/} hashes 32-bit
values together to generate its random numbers.

To generate normally distributed data \texttt{gasdev\/} creates two random
numbers $v_1$ and $v_2$.  We can create $R \equiv v_1^2 * v_2^2$. 
To produce two normal deviates,  we can set $y_1 = \sqrt{(-2*R)} * v_1/R$
and $y_2 = \sqrt{(-2*R)} * v_2/R$.

\subsection{Accuracy}

% A discussion of issues related to the accuracy of numerical routines
% used by \texttt{MyClass}---e.g., approximations,  argument ranges, etc.

The accuracy of the \texttt{random\/} suite is tested for in the test code
\texttt{trandom\/}.  Each function generates data which pass each test, 
however the $a$ and $m$ values for \texttt{ran0\/} and \texttt{ran1\/}
are suspect as they do not pass the spectral test.

\subsection{Performance}

% A discussion of issues related to the speed (e.g., $O(N\log N)$) of
% computationally demanding routines used by \texttt{MyClass}.

The relative performance of the \texttt{random\/} functions is given in
\textit{Numerical Recipies in C\/}.  With $\mathtt{ran0} \equiv 1.0$,
$\mathtt{ran1} = 1.3$, $\mathtt{ran2} = 2.0$, $\mathtt{ran3} = 0.6$,
and $\mathtt{ran4} = 4.0$.  

\subsection{Testing}

% A description of any test code/test classes that were used to test
% \texttt{MyClass}. 

\texttt{random\/} is tested by the \texttt{trandom\/}
test-harness. All the tests are described in more detail in
the trandom.cc file.

The first 8 tests are all based on $\chi^2$
tests.  Thus an ideal results per degree of 
freedom would be close to 1.  The range of pass
values differs for each test depending on the
number of trials and degrees of freedom for each
test.  

The collision test measures the number of collisions
of $n$ balls thrown into $m$ urns.  For the particular
choice of $n$ and $m$ used in this test pass values range
from 108 to 145.

The serial correlation test measures the correlation
between consecutive values generated by the functions.
Results close to zero indicate low correlation, which
is desirable.

The spectral test measures the "goodness" of the
random number generators.  The test is only able
to test \texttt{ran0\/}, \texttt{ran1\/}, and 
\texttt{ran2\/}.  \texttt{ran0\/} and \texttt{ran1\/} use
the same values for a and m while ran2 uses two
different values to randomize both half of the bits
in the number.  From \textit{The Art of Computer Programming"}:
"all good generators pass this test, all generators
now known to be bad actually fail it."

The normal distribution test checks that \texttt{gasdev\/}
generates random sequences of normally distributed
data.  The mean of the data should be near zero
and the variance should be close to one.  The test
makes sure that the observed values are close enough
given the number of samples.

The following is the output of a run of \texttt{trandom\/}
with my comments for each test.  The tests were run with
a typical seed value.  Results should be similar for other
typical seed values.

\begin{description}
\item [Frequency Test]
The frequency tests all pass for each function
with no really interesting results.
\begin{itemize}
\item PASS: Frequency Test for ran0
\item MESG: Results per degree of freedom: 1.07508
\item PASS: Frequency Test for ran1
\item MESG: Results per degree of freedom: 1.04229
\item PASS: Frequency Test for ran2
\item MESG: Results per degree of freedom: 0.976145
\item PASS: Frequency Test for ran3
\item MESG: Results per degree of freedom: 0.805418
\item PASS: Frequency Test for ran4
\item MESG: Results per degree of freedom: 0.757345
\end{itemize}
\item [Serial Test]
The serial tests all pass for each function
with no really interesting results.
\begin{itemize}
\item PASS: Serial Test for ran0
\item MESG: Result per degree of freedom: 0.971829
\item PASS: Serial Test for ran1
\item MESG: Result per degree of freedom: 0.992557
\item PASS: Serial Test for ran2
\item MESG: Result per degree of freedom: 1.00568
\item PASS: Serial Test for ran3
\item MESG: Result per degree of freedom: 1.00392
\item PASS: Serial Test for ran4
\item MESG: Result per degree of freedom: 0.954142
\end{itemize}
\item [Gap Test]
The gap test results are interesting in that 4
out of the 5 tests have results that are pretty
close (but not too close) to the expected results
for random data.
\begin{itemize}
\item PASS: Gap Test for ran0
\item MESG: Result per degree of freedom: 0.753527
\item PASS: Gap Test for ran1
\item MESG: Result per degree of freedom: 0.444037
\item PASS: Gap Test for ran2
\item MESG: Result per degree of freedom: 1.29012
\item PASS: Gap Test for ran3
\item MESG: Result per degree of freedom: 0.628977
\item PASS: Gap Test for ran4
\item MESG: Result per degree of freedom: 0.658253
\end{itemize}
\item [Poker Test]
The poker test results also tend to be too close
to the expected values for most cases.  It is
interesting that the \texttt{ran4\/} test is actually pretty
far away from the expected results.  The low
results are probaby due to the small number of bins
that are possible (1 to 5 with 4 and 5 lumped together),
however, it would not make a significant difference to
increase the bin number as the probabilities drop off too
fast to bother with higher values.
\begin{itemize}
\item PASS: Poker Test for ran0
\item MESG: Result per degree of freedom: 0.138586
\item PASS: Poker Test for ran1
\item MESG: Result per degree of freedom: 0.390312
\item PASS: Poker Test for ran2
\item MESG: Result per degree of freedom: 0.868446
\item PASS: Poker Test for ran3
\item MESG: Result per degree of freedom: 0.596404
\item PASS: Poker Test for ran4
\item MESG: Result per degree of freedom: 1.87791
\end{itemize}
\item [Coupon Collector Test]
The coupon tests all pass for each function
with no really interesting results.
\begin{itemize}
\item PASS: Coupon Test for ran0
\item MESG: Result per degree of freedom: 0.813172
\item PASS: Coupon Test for ran1
\item MESG: Result per degree of freedom: 1.04114
\item PASS: Coupon Test for ran2
\item MESG: Result per degree of freedom: 0.760678
\item PASS: Coupon Test for ran3
\item MESG: Result per degree of freedom: 1.20112
\item PASS: Coupon Test for ran4
\item MESG: Result per degree of freedom: 0.825255
\end{itemize}
\item [Permutation Test]
The permutation tests all pass for each function
with no really interesting results.
\begin{itemize}
\item PASS: Permutation Test for ran0
\item MESG: Result per degree of freedom: 1.00934
\item PASS: Permutation Test for ran1
\item MESG: Result per degree of freedom: 0.989021
\item PASS: Permutation Test for ran2
\item MESG: Result per degree of freedom: 0.994239
\item PASS: Permutation Test for ran3
\item MESG: Result per degree of freedom: 0.99083
\item PASS: Permutation Test for ran4
\item MESG: Result per degree of freedom: 0.994865
\end{itemize}
\item [Run Test]
The run tests have a couple of results which are
close to zero.  The reason behind this is the same
as that for the poker test.  A low number of bins
and decreasing probablities for higher numbers of 
bins.
\begin{itemize}
\item PASS: Run Test for ran0
\item MESG: Result per degree of freedom is: 1.28648
\item PASS: Run Test for ran1
\item MESG: Result per degree of freedom is: 1.29313
\item PASS: Run Test for ran2
\item MESG: Result per degree of freedom is: 0.584151
\item PASS: Run Test for ran3
\item MESG: Result per degree of freedom is: 0.860958
\item PASS: Run Test for ran4
\item MESG: Result per degree of freedom is: 0.434433
\end{itemize}
\item [Maximum-of-T Test]
The Maximum-of-5 tests all pass for each function
with no really interesting results.
\begin{itemize}
\item PASS: Maximum-of-5 test for ran0
\item MESG: Result per degree of freedom: 0.851343
\item PASS: Maximum-of-5 test for ran1
\item MESG: Result per degree of freedom: 0.872596
\item PASS: Maximum-of-5 test for ran2
\item MESG: Result per degree of freedom: 1.16754
\item PASS: Maximum-of-5 test for ran3
\item MESG: Result per degree of freedom: 1.0054
\item PASS: Maximum-of-5 test for ran4
\item MESG: Result per degree of freedom: 1.11532
\end{itemize}
\item [Collision Test]
The collision tests all pass for each function
with no really interesting results.
\begin{itemize}
\item PASS: Collision Test for ran0
\item MESG: Total number of hits: 126
\item Expected number of hits: approximately 128
\item PASS: Collision Test for ran1
\item MESG: Total number of hits: 136
\item Expected number of hits: approximately 128
\item PASS: Collision Test for ran2
\item MESG: Total number of hits: 115
\item Expected number of hits: approximately 128
\item PASS: Collision Test for ran3
\item MESG: Total number of hits: 110
\item Expected number of hits: approximately 128
\item PASS: Collision Test for ran4
\item MESG: Total number of hits: 133
\item Expected number of hits: approximately 128
\end{itemize}  
\item [Serial Correlation Test]
The serial correlation tests all pass for each
function with no really interesting results.
\begin{itemize}
\item PASS: Serial Correlation Test for ran0
\item MESG: Correlation Coefficient is: 0.0293086
\item PASS: Serial Correlation Test for ran1
\item MESG: Correlation Coefficient is: 0.00659433
\item PASS: Serial Correlation Test for ran2
\item MESG: Correlation Coefficient is: -0.02898
\item PASS: Serial Correlation Test for ran3
\item MESG: Correlation Coefficient is: -0.00221477
\item PASS: Serial Correlation Test for ran4
\item MESG: Correlation Coefficient is: 0.0091977
\end{itemize}
\item [Spectral Test]
The spectral test for \texttt{ran0\/} and \texttt{ran1\/} fails.
This is due to poor choices of $m$ and $a$ values.
\begin{itemize}
\item MESG: v2 = 16807 > 32768?
\item MESG: v3 = 638.903 > 1024?
\item MESG: v4 = 147.248 > 181.019?
\item MESG: v5 = 66.6258 > 64?
\item MESG: v6 = 29.9166 > 32?
\item FAIL: Spectral Test for ran0 and ran1
\item MESG: v2 = 40014 > 32768?
\item MESG: v3 = 1210.18 > 1024?
\item MESG: v4 = 201.844 > 181.019?
\item MESG: v5 = 74.9466 > 64?
\item MESG: v6 = 37.4566 > 32?
\item PASS: Spectral Test for ran2 part 1
\item MESG: v2 = 40692 > 32768?
\item MESG: v3 = 1184.66 > 1024?
\item MESG: v4 = 206.095 > 181.019?
\item MESG: v5 = 80.666 > 64?
\item MESG: v6 = 37.921 > 32?
\item PASS: Spectral Test for ran2 part 2
\end{itemize}
\item [Normal Distribution Test]
There is nothing exceptionally interesting about the results
of the normal distribution's tests.
\begin{itemize}
\item PASS: Normal Distribution's mean is close enough to zero
\item MESG: For 81 numbers the mean is: 0.129443
\item PASS: Normal Distribution's variance is close enough to one
\item MESG: For 81 numbers the variance is: 0.799163
\end{itemize}
\end{description}

These tests are from \textit{The Art of Computer Programming}
by Knuth, section 3.3.2 except the Spectral Test, which is from
section 3.3.4, and the Normal Distribution Test.

\subsection{Notes}

% Miscellaneous notes about \texttt{MyClass} that do not appear
% elsewhere, things that remain to be done, etc.  

\textbf{Note:  This discussion of the spectral test may no longer be valid a new value of $a$ has been used.}

The $a$ and $m$ values for \texttt{ran0\/} and \texttt{ran1\/} fail the 
Spectral Test.  This suggests that sequences generated from these 
functions may be suspect even though the pass all other applicable tests.

While it is possible to just use the \texttt{getran\/} or \texttt{getgasdev\/} functions from
the state classes, it is not recommended.

Eventually the \texttt{gasdevstate\/} object will be able to use any available random number
generator, including ones not in the random function.  However, this functionality has yet to 
be implimented.

\subsection{See Also}

% A list of derived classes, base classes, etc.\ closely related to
% \texttt{MyClass}. 

state classes for the respective functions (\texttt{ran0state\/},
\texttt{ran1state\/}, \texttt{ran2state\/}, \texttt{ran3state\/}, \texttt{ran4state\/},
\texttt{gasdevstate\/})

Another random number generator in LDAS is in \texttt{mt19937} files.

\subsection{References}

% A list of references for any algorithms, etc.\ used by {\tt
% MyClass}. 
The code for the \texttt{random\/} fuctions came from
\textit{Numerical Recipes in C\/} chapter 7. Most of the test codes for
\texttt{trandom\/} came from \textit{The Art of Computer Programming\/}.


\input Tail


%%% Local Variables: 
%%% mode: latex
%%% TeX-master: "datacondAPI"
%%% End: 
